#ifndef _RINGBUFFER_H_
#define _RINGBUFFER_H_

typedef struct ringbuffer {
    char *pool;
    unsigned int read_index;
    unsigned int write_index;
    unsigned int mask_index;
    unsigned int size;
}RingBuffer, *RingBuffer_t;


int RingBufferInit(RingBuffer_t rb, char *buf, unsigned int size);
int RingBufferWrite(RingBuffer_t rb, char *buf, int length);
int RingBufferReadByte(RingBuffer_t rb, char *buf, int length);
int RingBufferDataLength(RingBuffer_t rb);
int RingBufferEmpty(RingBuffer_t rb);
#define RingBufferSpace(rb) (rb->size - RingBufferDataLength(rb))

#endif
